

//*****************************************************************************
// Steffen from "Mikrocontrollerspielwiese" wrote this file for an easier
// using of ADC0..5 on atmega8. The program takes the analogue values of 
// the called channels and uses average values to avoid noise errors.
// 
// You find it at http://www.mikrocontrollerspielwiese.de
//
// license: GPL (http://www.gnu.org/licenses/gpl.txt)
//
// have fun!
//*****************************************************************************


int MESSWERT (int kanal){

  	int i=512,j=512;
  	long int analogwert=0, analogwert1=0, analogwert2=0 ;
	
	while(j){
  		
		while(i){
			ADCSRA=0x80; 		// ADC eingeschaltet, kein Prescale 
			ADMUX=kanal;  		// ADC Ref auf Avcc, PC0 gewaehlt, normale Formatierung
			ADCSRA |=_BV(ADSC); 	// single conversion mode ein
			while (ADCSRA & (1<<ADSC)) {;}	// auf Abschluss der Konvertierung warten 
			analogwert+=ADCW;
			i--;
		}
		
		analogwert1 = analogwert/512;
		analogwert2 += analogwert1;
		j--;
	}
	
	analogwert=(analogwert2/512);

	return (analogwert);
}


