

#include <avr/io.h>
#include <stdio.h>
#include <inttypes.h>


#include <avr/wdt.h>
#include <avr/interrupt.h>


#define F_CPU 1000000 // CPU-Frequenz in Hz
#include <util/delay.h>

#include "messen.h"
#include "lcd-routines.h"



void warte (int t){
	while(t){
		_delay_ms(250);
		_delay_ms(250);
		_delay_ms(250);
		_delay_ms(250);
		t--;
	}
}



int main(void){
	DDRB|=_BV(PB0); PORTB|=_BV(PB0);//Status LED1
	DDRD|=_BV(PD7); PORTD|=_BV(PD7);//Status LED2
	
	int i, x, anzahl;
	char zahlstring[3];
	
	lcd_init();
	
	
	
		lcd_clear();
		warte(2);
		
		set_cursor(0, 1);lcd_string("  Ja ja ja !");warte(1);
		set_cursor(0, 2);lcd_string("  Ich bin es:");
		warte(6);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Das universelle");
		set_cursor(0, 2);lcd_string("   LCD Board !");
		warte(9);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("  Was ich so");
		set_cursor(0, 2);lcd_string("  alles kann:");
		warte(3);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Beliebigen Text");
		set_cursor(0, 2);lcd_string("   ausgeben!");
		warte(3);
				
		lcd_clear();
		set_cursor(0, 1);lcd_string("  Meine LEDs");
		set_cursor(0, 2);lcd_string("blinken lassen.");
		_delay_ms(200);
		i=4;
		while(i){
			PORTB &=~_BV(PB0);_delay_ms(150);
			PORTB |=_BV(PB0);_delay_ms(150);
			i--;
		}
		i=4;
		while(i){
			PORTD &=~_BV(PD7);_delay_ms(150);
			PORTD |=_BV(PD7);_delay_ms(150);
			i--;
		}
		i=4;
		while(i){
			PORTB &=~_BV(PB0);PORTD |=_BV(PD7);_delay_ms(150);
			PORTD &=~_BV(PD7);PORTB |=_BV(PB0);_delay_ms(150);
			i--;
		}		
		PORTD |=_BV(PD7);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Ich kann Ereig-");
		set_cursor(0, 2);lcd_string("nisse z\xE1hlen:");
		i=0;
		while(i<=10){
			sprintf(zahlstring, "%d", i);
			set_cursor(14, 2);
			lcd_string(zahlstring);
			_delay_ms(255);_delay_ms(255);
			i++;
		}
		warte(1);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("  Die Uhrzeit");
		set_cursor(0, 2);lcd_string("   anzeigen.");
		warte(2);
		i=55;
		while(i<60){
			sprintf(zahlstring, "11:59:%d  ", i);
			set_cursor(3, 2);lcd_string(zahlstring);
			warte(1);
			i++;
		}
		lcd_clear();
		set_cursor(0, 1);lcd_string("   Mittag !  ");
		set_cursor(3, 2);lcd_string("12:00:00 ");
		warte(3);

		
		lcd_clear();
		set_cursor(0, 1);lcd_string("   Ich habe 9");
		set_cursor(0, 2);lcd_string("   Anschl\xF5sse.");
		warte(5);
				
		lcd_clear();
		set_cursor(0, 1);lcd_string("damit kann ich:");
		warte(3);
		
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("9 Ger\xE1te ein-");
		set_cursor(0, 2);lcd_string("und ausschalten.");
		warte(5);
		
		
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Bis zu 6 analoge");
		set_cursor(0, 2);lcd_string("Werte messen:");
		warte(4);
		lcd_clear();
		set_cursor(0, 1);lcd_string("0.01");_delay_ms(200);
		set_cursor(6, 1);lcd_string("0.04");_delay_ms(200);
		set_cursor(12, 1);lcd_string("0.03");_delay_ms(200);
		set_cursor(0, 2);lcd_string("0.01");_delay_ms(200);
		set_cursor(6, 2);lcd_string("0.09");_delay_ms(200);
		set_cursor(12, 2);lcd_string("0.02");_delay_ms(200);
		warte(1);
		set_cursor(0, 1);lcd_string("0.02");_delay_ms(200);
		set_cursor(6, 1);lcd_string("0.03");_delay_ms(200);
		set_cursor(12, 1);lcd_string("0.04");_delay_ms(200);
		set_cursor(0, 2);lcd_string("0.02");_delay_ms(200);
		set_cursor(6, 2);lcd_string("0.07");_delay_ms(200);
		set_cursor(12, 2);lcd_string("0.03");_delay_ms(200);
		warte(1);
		set_cursor(0, 1);lcd_string("0.01");_delay_ms(200);
		set_cursor(6, 1);lcd_string("0.04");_delay_ms(200);
		set_cursor(12, 1);lcd_string("0.03");_delay_ms(200);
		set_cursor(0, 2);lcd_string("0.01");_delay_ms(200);
		set_cursor(6, 2);lcd_string("0.09");_delay_ms(200);
		set_cursor(12, 2);lcd_string("0.02");_delay_ms(200);
		warte(1);
		set_cursor(0, 1);lcd_string("0.02");_delay_ms(200);
		set_cursor(6, 1);lcd_string("0.03");_delay_ms(200);
		set_cursor(12, 1);lcd_string("0.04");_delay_ms(200);
		set_cursor(0, 2);lcd_string("0.02");_delay_ms(200);
		set_cursor(6, 2);lcd_string("0.07");_delay_ms(200);
		set_cursor(12, 2);lcd_string("0.03");_delay_ms(200);
		warte(1);
		
				
		lcd_clear();
		set_cursor(0, 1);lcd_string(" Auch quasiana-");
		set_cursor(0, 2);lcd_string(" log, wie hier:");
		warte(4);
		
		x=0; anzahl=10;
		set_cursor(0, 1); lcd_string("0  1  2  3  4  5");
		while (anzahl)    {
			anzahl--;
			
			x=MESSWERT(0)/60.18;
   
			set_cursor(0, 2); lcd_string("                ");
			set_cursor(x, 2); lcd_string("|");
       
			_delay_ms(255);
		}   
		
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("3 PWM-Signale");
		set_cursor(0, 2);lcd_string("ausgeben, z. B.");
		warte(5);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("f\xF5r 3 Servos od.");
		set_cursor(0, 2);lcd_string("3 Analogsignale.");
		warte(5);
			
		lcd_clear();
		set_cursor(0, 2);lcd_string("   Ich kann:");
		warte(3);
				
		lcd_clear();
		set_cursor(0, 1);lcd_string("Zust\xE1nde in me-"); //bei 9 sind's 512
		set_cursor(0, 2);lcd_string("chatronischen ...");
		warte(4);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Systemen anzei-");
		set_cursor(0, 2);lcd_string("gen und steuern.");
		warte(6);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Ich kann sogar:");
		warte(3);
		
		for(i=0;i<7;i++){
			lcd_clear();
			_delay_ms(250);_delay_ms(250);
			set_cursor(0, 1);lcd_string("Die Lottozahlen ");
			set_cursor(0, 2);lcd_string("voraussagen...");
			_delay_ms(250);_delay_ms(250);
		}
		
		lcd_clear();
		set_cursor(0, 1);lcd_string(" ...jedenfalls");
		set_cursor(0, 2);lcd_string(" versuchsweise.");
		warte(6);
				
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Ich bin pro-");
		set_cursor(0, 2);lcd_string("grammierbar...");
		warte(6);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("...immer und");
		set_cursor(0, 2);lcd_string("  immerwieder,");
		warte(6);
		
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("denn mein Herz");
		set_cursor(0, 2);lcd_string("ist ein Atmega8.");
		warte(6);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Meine Betriebs-");
		set_cursor(0, 2);lcd_string("spannung: 5..35V");
		warte(6);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string(" Ich wurde er-");
		set_cursor(0, 2);lcd_string("dacht und gebaut");
		warte(6);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("von St. M\xF5ller &");
		set_cursor(0, 2);lcd_string(" C. Koczielski.");
		warte(6);
		
		lcd_clear();
		set_cursor(0, 1);lcd_string("Mikrocontroller-");
		set_cursor(0, 2);lcd_string("   spielwiese");
		warte(10);
		
		// WATCHDOG
		cli();                     // Interrupts global abschalten
		wdt_enable (WDTO_15MS);    // Watchdog aufziehen auf 15ms
		while (1);                 // warten, bis er zubeisst...
	
 
    return 0;
}




